#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>

/*
gcc -Wall backtrace.c
objdump -T a.out
gcc -Wall backtrace.c -rdynamic
objdump -T a.out
*/

char test[] = "Dies ist ein test";

// this function will be called instead of another function.
void hackFunc(){
  int a = 4;
  int b = 10;
  printf("You have been hacked %d!\n", a*b + 2);  
}

int func(int val, const char* text){
	intptr_t rbp, rsp, callerFunction;	
	
	asm ("movq %%rsp, %0"  : "=r" (rsp) ); // stack pointer
	asm ("movq %%rbp, %0"  : "=r" (rbp)); // frame pointer
	
	// the actual pointer to the calling code
	asm ("movq 4(%%rbp), %0"  : "=r" (callerFunction)); 

	
	printf("callerPointer: %p rbp-var: %p rsp-var: %p val: %p text: %p --- rsp: %p rbp: %p\n", (void*) callerFunction, & rbp, & rsp, & val, & text, (void *) rsp, (void *) rbp);
	
	// nested call, just for demo purpose
	if(val == 3){
	   return func(2, test) * 2;
	}
	
	// change the instruction pointer to hackFunc
	void * target = (void*) (((long) hackFunc << 32) + (callerFunction >>32) ) ; // get offst to text segment ?
	printf("jumping to: %p\n", target);	
	asm ("movq %0, 4(%%rbp)"  : /* no output*/
			       : "r" (target) ); 
	
	return val*2;
}

int main(){  
	printf("Functions: main: %p func: %p hackFunc: %p\n", main, func, hackFunc);
	
	int ret = func(3, test);	
	
	printf("correct return value: %d\n", ret);
	
	return 0;
}
